NTDdata <- matrix(scan("c:/data/statisticalmodelling/NTDdata.txt"), ncol = 4, byrow = T)
colnames(NTDdata) <- c("lvr1","lvr2","lnr","birth.weight")
# replace missing birth weight with median for capture-profile
capture.profile <- 
    ifelse(NTDdata[,"lvr1"] == 1 & NTDdata[,"lvr2"] == 0 & NTDdata[,"lnr"] == 0, 1, 0) +
    ifelse(NTDdata[,"lvr1"] == 0 & NTDdata[,"lvr2"] == 1 & NTDdata[,"lnr"] == 0, 2, 0) +
    ifelse(NTDdata[,"lvr1"] == 0 & NTDdata[,"lvr2"] == 0 & NTDdata[,"lnr"] == 1, 3, 0) +
    ifelse(NTDdata[,"lvr1"] == 1 & NTDdata[,"lvr2"] == 1 & NTDdata[,"lnr"] == 0, 4, 0) +
    ifelse(NTDdata[,"lvr1"] == 1 & NTDdata[,"lvr2"] == 0 & NTDdata[,"lnr"] == 1, 5, 0) +
    ifelse(NTDdata[,"lvr1"] == 0 & NTDdata[,"lvr2"] == 1 & NTDdata[,"lnr"] == 1, 6, 0) +
    ifelse(NTDdata[,"lvr1"] == 1 & NTDdata[,"lvr2"] == 1 & NTDdata[,"lnr"] == 1, 7, 0) 
NTDdata <- cbind(NTDdata, capture.profile)
median.birth.weight <- median(
    NTDdata[NTDdata[,"lvr1"] == NTDdata[is.na(NTDdata[,"birth.weight"]),"lvr1"]&
        NTDdata[,"lvr2"] == NTDdata[is.na(NTDdata[,"birth.weight"]),"lvr2"]&
            NTDdata[,"lnr"] == NTDdata[is.na(NTDdata[,"birth.weight"]),"lnr"],"birth.weight"], na.rm = TRUE)
missing.index <- (1:length(NTDdata[,"birth.weight"]))[is.na(NTDdata[,"birth.weight"])]
NTDdata[missing.index,"birth.weight"] <- median.birth.weight
#### Create Table 1
table1 <- rbind(c(table(NTDdata[,"capture.profile"]),length(NTDdata[,"capture.profile"])),
    round(c(tapply(NTDdata[,"birth.weight"],NTDdata[,"capture.profile"],mean,na.rm = T),
        mean(NTDdata[,"birth.weight"],na.rm=T)),3),
   round(c(tapply(NTDdata[,"birth.weight"],NTDdata[,"capture.profile"],sd,na.rm=T),
        sd(NTDdata[,"birth.weight"],na.rm=T))/
                sqrt(c(table(NTDdata[,"capture.profile"]),length(NTDdata[,"capture.profile"]))),3))
dimnames(table1) <- list(c("Observed","Mean delivery weight","s.e"),
    c("100","010","001","110","101","011","111","Total"))
table1
# Source model fitting program
source("C:/data/statisticalmodelling/CoxPH.R") # 'coxph' wrapper function for fitting Bock model
y.constraint <- matrix( # Y-design matrix
    c(1,0,0,1,1,0,1,
      0,1,0,1,0,1,1,
      0,0,1,0,1,1,1,
      0,0,0,1,0,0,1,
      0,0,0,0,1,0,1,
      0,0,0,0,0,1,1),nrow=6,ncol=7,T)
obsMA <- nrow(NTDdata) # numbder observed at least once
#### Fit log-linear models
x.matrix <- matrix(rep(1,length(NTDdata[,"birth.weight"])), ncol = 1) # X-covariate matrix, with intercept only
d.matrix <- cbind(capture.profile == 1,capture.profile == 2,capture.profile == 3,capture.profile == 4,
    capture.profile == 5,capture.profile == 6,capture.profile == 7)
# 
# Here we fit all models and then combine the results
model1 <- coxph.CRC(d.matrix,y.constraint[1:3,],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <-     c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval)
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,4),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,5),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,6),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,4,5),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,4,6),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,5,6),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint,x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
rownames(parameters.MA) <- c("[1D,2D,3D]","[12D,3D]","[13D,2D]","[1D,23D]","[12D,13D]","[12D,23D]","[13D,23D]","[12D,13D,23D]")
colnames(parameters.MA) <- c("N_hat","AIC","V_1","V_2","lower","upper")
round(parameters.MA,2)

##### Multinomial logit model
x.matrix <- cbind(rep(1,length(NTDdata[,"birth.weight"])), 
                  NTDdata[,"birth.weight"])# X-covariate matrix including birth weight
model1 <- coxph.CRC(d.matrix,y.constraint[1:3,],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval)
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,4),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,5),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,6),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,4,5),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,4,6),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint[c(1:3,5,6),],x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
model1 <- coxph.CRC(d.matrix,y.constraint,x.matrix)
    # log-based confidence interval
    logC <- exp(1.96 * sqrt((log(1 + (sum(model1$AsymVar)+sum(model1$CondVar))/
        (model1$PopTotal - length(NTDdata[,"birth.weight"]))^2))))
    confidence.interval <- cbind(length(NTDdata[,"birth.weight"]) + (model1$PopTotal - obsMA)/logC,
        obsMA + (model1$PopTotal - length(NTDdata[,"birth.weight"]))*logC)
parameters.MA <- rbind(parameters.MA,
    c(model1$PopTotal,model1$AIC,sum(model1$CondVar),sum(model1$AsymVar),confidence.interval))
rownames(parameters.MA) <- c("[1D,2D,3D]","[12D,3D]","[13D,2D]","[1D,23D]","[12D,13D]","[12D,23D]","[13D,23D]","[12D,13D,23D]")
colnames(parameters.MA) <- c("N_hat","AIC","V_1","V_2","lower","upper")
round(parameters.MA,2)

######## Model averaging
aic.weights <- exp(-(parameters.MA[,2]-min(parameters.MA[,2]))/2)/
    sum(exp(-(parameters.MA[,2]-min(parameters.MA[,2]))/2))
popMA <- sum(aic.weights * parameters.MA[,1])
sdMA <- sum(aic.weights * sqrt(rowSums(parameters.MA[,c(3,4)]) + 
    (parameters.MA[,1] - sum(aic.weights * parameters.MA[,1]))^2))
varMA <- sdMA^2 + popMA;sdMA;varMA
log.C <- exp(1.96 * sqrt((log(1 + varMA/(popMA - obsMA)^2))))
cat("Asymptotic confidence interval\n");cat("lower interval",popMA-2*sdMA,"lower interval",popMA+2*sdMA,"\n")
#### CI on log
cat("Confidence interval on log-scale\n");cat("lower interval",obsMA + (popMA - obsMA)/log.C,"lower interval",obsMA + (popMA - obsMA) * log.C,"\n")


###### Notice that rather than use "coxph" the models can also be fitted using VGAM
# for instance the Alho/Huggins model (with covariates)
x.matrix <- cbind(rep(1,length(NTDdata[,"birth.weight"])), 
                  NTDdata[,"birth.weight"])# X-covariate matrix including birth weight
y.constraint <- matrix( # Y-design matrix
    c(1,0,0,1,1,0,1,
      0,1,0,1,0,1,1,
      0,0,1,0,1,1,1,
      0,0,0,1,0,0,1,
      0,0,0,0,1,0,1,
      0,0,0,0,0,1,1),nrow=6,ncol=7,T)##### Using Bock's multinomial logit model
source("C:/data/statisticalmodelling/CoxPH.R") # 'coxph' wrapper function for fitting Bock model
model1 <- coxph.CRC(d.matrix,y.constraint[1:3,],x.matrix)
model1$Lambdas
#
##### Using VGAM library
library(VGAM)
d.weight <- NTDdata[,"birth.weight"]
    # Y-specified via "constraints" function. To be equivalent to Bock's model, simply remove 
    # column corresponding to observations listed in all lists, substract 1 and transpose.
model2 <- vglm(d.matrix ~ d.weight, multinomial, 
    constraints=list("(Intercept)" = t(y.constraint[1:3,-7]) - 1, d.weight = t(y.constraint[1:3,-7]) - 1))
coef(model2)
